#pragma once
#include <map>
#include <SDL_stdinc.h>

class FontFace {
public:
  FontFace(const char* filename_ttf);
  void RenderGlyph(int chr);
  void RenderString(const char* str);
  void RenderMarkup(const char* str);
  void MeasureString(const char* str, float& w, float& h);

  /* Of Ms. */
  float GetHeight(void) { return m_height; }
  float GetWidth(void)  { return m_width; }

private:
  float m_height;
  float m_width;
  
  struct glfglyph_t {
    float* varray;
    Uint16* iarray;
    int numidx;
    float advx, advy;
  };
  std::map<int, glfglyph_t> m_glyphs;
};

class TextureFontFace {
public:
  TextureFontFace(const char* filename_ttf, int width, int height);
  void RenderGlyph(int chr);
  void LayoutString(const char* _str, float maxWidth);
  void MeasureLayout(const char* str, const float maxWidth, float outSize[2]);
  void RenderString(const char* str);
  void RenderMarkup(const char* str);
  void MeasureString(const char*str, float& w, float& h);
  /* Of Ms. */
  float GetHeight(void) { return m_height; }
  float GetWidth(void)  { return m_width; }

private:
  float m_height;
  float m_width;
  float m_descender;
  int m_texSize, m_pixSize;
  struct glfglyph_t {
    unsigned int tex;
    float advx, advy;
    float width, height;
    int offx, offy;
  };
  std::map<int, glfglyph_t> m_glyphs;
};
void GLFTInit(void);

