#pragma once
#include "gui_container.h"

namespace Gui {
class VScrollPortal: public Container {
public:
  VScrollPortal(float w, float h);
  void Add(Widget* child);
  void Remove(Widget* child);
  virtual bool OnMouseDown(MouseButtonEvent* e);
  virtual bool OnMouseUp(MouseButtonEvent* e);
  virtual bool OnMouseMotion(MouseMotionEvent* e);
  virtual void Draw(void);
  virtual void GetSizeRequested(float size[2]);
  virtual void OnChildResizeRequest(Widget*);
  void SetBgColor(float rgb[3]);
  void SetBgColor(float r, float g, float b);
  Adjustment vscrollAdjust;
private:
  float GetScrollPixels();
  void OnScroll(float);
  float m_scrollY, m_childSizeY;
  Widget* m_cild;
};
}

